/*
 * File    : Main.java
 * Created : 28-Jan-2004
 * By      : parg
 * 
 * Azureus - a Java Bittorrent client
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details ( see the LICENSE file ).
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.gudy.azureus2.ui.webplugin.remoteui.applet.test;

/**
 * @author parg
 *
 */

import java.io.*;
import java.util.Properties;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import org.gudy.azureus2.core3.security.SESecurityManager;
import org.gudy.azureus2.core3.util.AEMonitor;
import org.gudy.azureus2.core3.util.AESemaphore;
import org.gudy.azureus2.core3.util.AEThread2;
import org.gudy.azureus2.plugins.*;
// import org.gudy.azureus2.plugins.utils.*;

import org.gudy.azureus2.ui.webplugin.remoteui.applet.*;


public class 
Main
	implements Plugin
{
	public void 
	initialize(
		PluginInterface _plugin_interface )
	
		throws PluginException
	{	
		try{
			
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
			
		}catch( Exception e ){
			
			e.printStackTrace();
		}
		
		/*
		UTTimer tim = _plugin_interface.getUtilities().createTimer("poo");
		
		tim.addPeriodicEvent(
			1000,
			new UTTimerEventPerformer()
			{
				
				public void
				perform(
					UTTimerEvent	ev )
				{
					System.out.println( "poo");
					
					try{
						PluginManager.stopAzureus();
					}catch( Throwable e ){
						
						e.printStackTrace();
					}
				}
			});
		*/
		
		/*
		_plugin_interface.getDownloadManager().addListener(
				new DownloadManagerListener()
				{
					public void
					downloadAdded(
						Download	download )
					{
						Torrent t = download.getTorrent();
						
						System.out.println( "torrent added:" + t.getName());
						
						try{
							
							t.getAnnounceURLList().insertSetAtFront(new URL[]{new URL("http://plopp/")});
							
							t.save();
							
						}catch( Throwable e ){
							
							e.printStackTrace();
						}
					}
					
					public void
					downloadRemoved(
						Download	download )
					{
					}
				});
		*/
		
		final JFrame	frame = new JFrame( "Azureus Swing UI" );

		frame.addWindowListener(
			new WindowAdapter()
			{
				public void
				windowClosing(
					WindowEvent	ev )
				{
					SESecurityManager.exitVM(0);
				}
			});
		
		frame.setSize(600,300);

		Container cont = frame.getContentPane();
		
		cont.setLayout( new BorderLayout());
		
		RemoteUIMainPanel	panel = 
			new RemoteUIMainPanel( 
					_plugin_interface, 
					_plugin_interface.getDownloadManager(),
					new RemoteUIMainPanelAdaptor()
					{
						public InputStream
						getResource(
							String		name )
						{
							return( getClass().getClassLoader().getResourceAsStream( "org/gudy/azureus2/ui/icons/" + name ));
						}
						
						public void
						refresh()
						{
						}
						
						public void
						error(
							final Throwable 		e )
						{
							e.printStackTrace();
							
							SwingUtilities.invokeLater(
									new Runnable()
									{
										public void
										run()
										{
											String	message_chain = "";
											
											Throwable	temp = e;
											
											while( temp != null ){
												
												String	this_message = temp.getMessage();
												
												if ( this_message != null ){
													
													message_chain += (message_chain.length()==0?"":"\n") + this_message;
												}
												
												temp = temp.getCause();
											}
														
											final String	message = message_chain.length()==0?e.toString():message_chain;
	
											JOptionPane.showMessageDialog( 
													frame, 
													message,
													"Error Occurred",  
													JOptionPane.ERROR_MESSAGE );
										}
									});
						}
					});
		
		cont.add( panel );	
		
		frame.setVisible(true);
	}	
	
	private static AESemaphore		init_sem 	= new AESemaphore("PluginTester");
	private static AEMonitor		class_mon	= new AEMonitor( "PluginTester" );


	private static Main		singleton;
		
	
	public static Main
	getSingleton()
	{
		try{
			class_mon.enter();
		
			if ( singleton == null ){
				
				new AEThread2( "plugin initialiser", false )
				{
					public void
					run()
					{
						PluginManager.registerPlugin( Main.class );
		
						Properties props = new Properties();
						
						props.put( PluginManager.PR_MULTI_INSTANCE, "true" );
						
						PluginManager.startAzureus( PluginManager.UI_NONE, props );
					}
				}.start();
			
				init_sem.reserve();
			}
			
			return( singleton );
			
		}finally{
			
			class_mon.exit();
		}
	}	
	
	public static void
	main(
		String[]	args )
	{
		getSingleton();
	}
}